"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reflectAll = void 0;
var BPromise = require("bluebird");
/**
 * Wait, even if an exception occurs in a single promise
 * @stable [27.02.2019]
 *
 * @param {Array<Promise<T>>} values
 * @returns {Bluebird<[Bluebird.Inspection<any> , any , any , any , any]>}
 */
exports.reflectAll = function (values) {
    return BPromise.all(values.map(function (promise) { return BPromise.cast(promise).reflect(); }));
};
//# sourceMappingURL=promise.js.map